﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace UpkeepOfWOW
{
    public partial class UpkeepOfWOWForm : Form
    {
        [DllImport("user32.dll")]
        public static extern IntPtr FindWindow(string lpClassName, string lpWindowName);

        [DllImport("user32.dll")]
        static extern int SendMessage(IntPtr hWnd, int msg, int wParam, int lParam);

        /// <summary>
        /// 메인 핸들 변수
        /// </summary>
        private IntPtr m_hWnd = IntPtr.Zero;
        public IntPtr hWnd
        {
            get { return m_hWnd; }
            set { m_hWnd = value; }
        }

        private bool m_isUpkeep = false;

        
        public UpkeepOfWOWForm()
        {
            InitializeComponent();

            timerUpkeep.Start();
        }
        
        #region Constants
        
        // Messages
        const int WM_KEYDOWN = 0x100;
        const int WM_KEYUP = 0x101;
        const int WM_CHAR = 0x105;
        const int WM_SYSKEYDOWN = 0x104;
        const int WM_SYSKEYUP = 0x105;
 
        #endregion
 
        public static void SendKey(string wName, Keys key)
        {
            IntPtr hWnd = DllImportLib.FindWindow(null, wName);
            //IntPtr hWnd = DllImportLib.FindWindowByCaption(IntPtr.Zero, wName);

            //IntPtr editHandle = DllImportLib.FindWindowEx(hWnd, IntPtr.Zero, "EDIT", null);

            DllImportLib.PostMessage(hWnd, WM_KEYDOWN, Convert.ToInt32(key), 0);
            //DllImportLib.SendMessage(hWnd, WM_CHAR, Convert.ToInt32(key), 0);
            DllImportLib.PostMessage(hWnd, WM_KEYUP, Convert.ToInt32(key), 0);
        }
 
        public static void SendSysKey(string wName, Keys key)
        {
            IntPtr hWnd = DllImportLib.FindWindow(null, wName);

            DllImportLib.PostMessage(hWnd, WM_SYSKEYDOWN, Convert.ToInt32(key), 0);
            DllImportLib.PostMessage(hWnd, WM_SYSKEYUP, Convert.ToInt32(key), 0);
        }
 
        public static void SendChar(string wName, char c)
        {
            IntPtr hWnd = DllImportLib.FindWindow(null, wName);

            DllImportLib.SendMessage(hWnd, WM_CHAR, (int)c, 0);
        }

        /// <summary>
        /// 해당 윈도우 핸들 얻기
        /// </summary>
        /// <returns></returns>
        public bool GetHandle()
        {
            string strWindowCaption = "월드 오브 워크래프트";

            hWnd = DllImportLib.FindWindowByCaption(IntPtr.Zero, strWindowCaption);

            if (hWnd != null)
            {
                return true;
            }

            //return false;
        }

        /// <summary>
        /// 타이머 Tick
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void timerUpkeep_Tick(object sender, EventArgs e)
        {
            // 접속유지가 켜져 있으면
            if(m_isUpkeep)
            {
                if (GetHandle() == true)
                {
                    // 메시지 실행
                    //DllImportLib.SendMessage(hWnd, WM_KEYDOWN, 'w', 0);
                    //DllImportLib.SendMessage(hWnd, WM_KEYDOWN, 's', 0);

                    string strWindowCaption = "월드 오브 워크래프트";
                    SendKey(strWindowCaption, Keys.W);
                    SendKey(strWindowCaption, Keys.S);

                    //SendSysKey(strWindowCaption, Keys.Alt);
                }
                else
                {
                    MessageBox.Show("창을 못찾았습니다.");
                }
            }
        }

        /// <summary>
        /// 종료
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonExit_Click(object sender, EventArgs e)
        {
            m_isUpkeep = false;
            Application.Exit();
        }

        /// <summary>
        ///  접속유지 클릭하면
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void checkBoxUpkeep_CheckedChanged(object sender, EventArgs e)
        {
            m_isUpkeep = checkBoxUpkeep.Checked;
        }
    }
}